<template>
  <q-page class="flex-center">
    <q-card>
      <q-card-section>
        <q-table
          :rows-per-page-options="[15, 25, 50]"
          :data="data"
          :columns="columns"
          separator="cell"
          :loading="loading"
          :pagination.sync="pagination"
          @request="onRequest"
          row-key="id"
        >
          <template slot="top" slot-scope="props">
            <q-btn
              push
              rounded
              color="primary"
              icon="add"
              @click="add()"
              v-show="permissions.includes('add_provider')"
            >
              Add Provider
            </q-btn>
            <div class="col" />
          </template>
          <q-tr slot="body" slot-scope="props" :props="props">
            <q-td
              key="No"
              :props="props"
              :style="{ width: '20px', whiteSpace: 'normal' }"
              >{{ props.row.No }}</q-td
            >
            <q-td
              key="name"
              :props="props"
              :style="{ width: '200px', whiteSpace: 'normal' }"
            >
              <q-btn
                color="teal"
                size="sm"
                :label="props.row.name"
                @click="opentype(props.row)"
              ></q-btn>
            </q-td>
            <q-td
              key="code"
              :props="props"
              :style="{ width: '100px', whiteSpace: 'normal' }"
              >{{ props.row.code }}</q-td
            >
            <q-td
              key="type_name"
              :props="props"
              :style="{ width: '100px', whiteSpace: 'normal' }"
              >{{ props.row.type_name }}
            </q-td>
            <q-td
              key="image"
              :props="props"
              :style="{ width: '100px', whiteSpace: 'normal' }"
            >
              <template>
                <img :src="ConvertImage(props.row.image)" class="image" />
              </template>
            </q-td>
            <q-td
              key="status"
              :props="props"
              :style="{ width: '20px', whiteSpace: 'normal' }"
            >
              <q-toggle
                v-model="props.row.status"
                @input="ChangeStatus(props.row)"
                :false-value="0"
                :true-value="1"
                v-show="permissions.includes('change_provider')"
              ></q-toggle>
              <!-- <q-btn size="sm" :color="btn[props.row.status].color" :label="btn[props.row.status].label" class="q-mr-sm" @click="ChangeStatus(props.row)" v-show="permissions.includes('change_provider')" /> -->
            </q-td>
            <q-td
              key="action"
              :props="props"
              :style="{ width: '5%', whiteSpace: 'normal' }"
            >
              <div class="row items-center justify-between no-wrap">
                <q-btn
                  size="sm"
                  round
                  rounded
                  color="secondary"
                  icon="edit"
                  @click="load(props.row)"
                  class="q-mr-xs"
                />
              </div>
            </q-td>
          </q-tr>

          <template v-slot:top-row>
            <q-tr>
              <q-td> </q-td>
              <q-td>
                <q-input
                  dense
                  debounce="300"
                  outlined
                  v-model="filter.name"
                  label="Filter Provider Name"
                  @input="getdata"
                ></q-input>
              </q-td>
              <q-td>
                <q-input
                  dense
                  debounce="300"
                  outlined
                  v-model="filter.code"
                  label="Filter Provider Code"
                  @input="getdata"
                ></q-input>
              </q-td>
              <q-td>
                <q-select
                  dense
                  debounce="300"
                  outlined
                  label="Select Type Game"
                  v-model="filter.type_id"
                  :options="type_options"
                  option-value="value"
                  option-label="label"
                  option-disable="inactive"
                  emit-value
                  map-options
                  @input="getdata"
                />
              </q-td>
              <q-td></q-td>
              <q-td>
                <q-select
                  dense
                  debounce="300"
                  outlined
                  label="Select Status"
                  v-model="filter.status"
                  :options="options"
                  option-value="value"
                  option-label="label"
                  option-disable="inactive"
                  emit-value
                  map-options
                  @input="getdata"
                />
              </q-td>
              <q-td></q-td>
            </q-tr>
          </template>
        </q-table>
      </q-card-section>
    </q-card>

    <!-- add provider -->
    <q-dialog
      full-width
      full-height
      v-model="modal_add"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card>
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form"
            :rules="rules"
            ref="form"
            label-width="180px"
            class="demo-ruleForm"
          >
            <el-form-item label="Name" prop="name">
              <el-input v-model="form.name"></el-input>
            </el-form-item>
            <el-form-item label="Code" prop="code">
              <el-input v-model="form.code"></el-input>
            </el-form-item>
            <el-form-item label="Type Game" prop="type">
              <q-select
                filled
                label="Select Type Game"
                v-model="form.type"
                :options="type_options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
                v-show="sessionTypeGame.includes('view_type')"
              />
            </el-form-item>
            <el-form-item label="Percent" prop="percent">
              <el-input-number
                v-model="form.percent"
                controls-position="right"
                :min="0"
                :max="100"
              ></el-input-number>
            </el-form-item>
            <el-form-item label="Commission" prop="commission">
              <el-input-number
                v-model="form.commission"
                controls-position="right"
                :min="0"
                :max="100"
              ></el-input-number>
            </el-form-item>
            <el-form-item label="Image" prop="image">
              <input
                type="file"
                id="file"
                ref="file"
                v-on:change="uploadProvider"
              />
            </el-form-item>
            <el-form-item>
              <img :src="ConvertImage(form.image)" class="image" />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-section>
          <q-table
            :rows-per-page-options="[15, 25, 50]"
            :data="game"
            :columns="columns_game"
            separator="cell"
            :filter="filter_game"
            :pagination.sync="pagination_game"
            row-key="id"
            v-show="sessionGame.includes('view_game')"
          >
            <template slot="top" slot-scope="props">
              <q-btn push rounded color="primary" icon="add" @click="addGame()"
                >Add Game</q-btn
              >
            </template>
            <q-tr slot="body" slot-scope="props" :props="props">
              <q-td
                key="No"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
                >{{ props.row.No }}</q-td
              >
              <q-td
                key="name"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
                >{{ props.row.name }}
              </q-td>
              <q-td
                key="code"
                :props="props"
                :style="{ width: '50px', whiteSpace: 'normal' }"
                >{{ props.row.code }}</q-td
              >
              <q-td
                key="type_id"
                :props="props"
                :style="{ width: '100px', whiteSpace: 'normal' }"
              >
                {{ getNameType(props.row.type_id) }}
              </q-td>
              <q-td
                key="image"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
              >
                <template>
                  <img :src="ConvertImage(props.row.image)" class="image" />
                </template>
              </q-td>
              <q-td
                key="status"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <q-toggle
                  v-model="props.row.status"
                  @input="ChangeStatusGame(props.row)"
                  :false-value="0"
                  :true-value="1"
                  v-show="sessionGame.includes('change_game')"
                ></q-toggle>
              </q-td>
              <q-td
                key="action"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <div class="row items-center justify-between no-wrap">
                  <q-btn
                    size="sm"
                    round
                    rounded
                    color="secondary"
                    icon="edit"
                    @click="loadgame(props.row)"
                    class="q-mr-xs"
                    v-show="sessionGame.includes('change_game')"
                  />
                </div>
              </q-td>
            </q-tr>
          </q-table>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn push rounded color="primary" @click="Create()">Submit</q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- end add -->

    <!-- add game -->
    <q-dialog
      v-model="modal_add_game"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw;">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_game"
            ref="form_game"
            :rules="rules_game"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Name" prop="name">
              <el-input v-model="form_game.name" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Code" prop="code">
              <el-input v-model="form_game.code" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Type Game" prop="type_id">
              <q-select
                filled
                label="Select Type Game"
                v-model="form_game.type_id"
                :options="type_options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
                v-show="sessionTypeGame.includes('view_type')"
              />
            </el-form-item>
            <el-form-item label="Image" prop="image">
              <input
                type="file"
                id="file"
                ref="file"
                v-on:change="uploadImage"
              />
            </el-form-item>
            <el-form-item>
              <img v-bind:src="`data:image/png;base64,${form_game.image}`" />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn
            push
            rounded
            color="primary"
            @click="insert()"
            v-show="sessionGame.includes('add_game')"
            >Submit</q-btn
          >
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- update game -->
    <q-dialog
      v-model="modal_edit_game"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw;">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="edit_game"
            ref="edit_game"
            :rules="rules_game_edit"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Name" prop="name">
              <el-input v-model="edit_game.name" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Code" prop="code">
              <el-input v-model="edit_game.code" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Type Game" prop="type_id">
              <q-select
                filled
                label="Select Type Game"
                v-model="edit_game.type_id"
                :options="type_options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
                v-show="sessionTypeGame.includes('view_type')"
              />
            </el-form-item>
            <el-form-item label="Image" prop="image">
              <input
                type="file"
                id="file"
                ref="file"
                v-on:change="uploadImageEdit"
              />
            </el-form-item>
            <el-form-item>
              <img :src="ConvertImage(edit_game.image)" class="image" />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn
            push
            rounded
            color="primary"
            @click="UpdateGame()"
            v-show="sessionGame.includes('change_game')"
          >
            Submit
          </q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- add type -->

    <q-dialog
      full-width
      full-height
      v-model="modal_type"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card>
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <q-table
            :rows-per-page-options="[15, 25, 50]"
            :data="data_type"
            :columns="columns_type"
            separator="cell"
            row-key="id"
            v-show="sessionService.includes('view_serviceprovider')"
          >
            <template slot="top" slot-scope="props">
              <q-btn push rounded color="primary" icon="add" @click="addType()"
                >Add Type</q-btn
              >
            </template>
            <q-tr slot="body" slot-scope="props" :props="props">
              <q-td
                key="No"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
                >{{ props.row.No }}</q-td
              >
              <q-td
                key="provider"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
              >
                {{ props.row.provider_name }}
              </q-td>
              <q-td
                key="type_name"
                :props="props"
                :style="{ width: '100px', whiteSpace: 'normal' }"
              >
                {{ props.row.type_name }}
              </q-td>
              <!-- <q-td key="type_playlist_name" :props="props" :style="{width: '100px', whiteSpace: 'normal'}">{{ props.row.type_playlist_name }}</q-td> -->
              <q-td
                key="status"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <q-toggle
                  v-model="props.row.status"
                  @input="ChangeStatusService(props.row)"
                  :false-value="0"
                  :true-value="1"
                  v-show="permissions.includes('change_provider')"
                ></q-toggle>
              </q-td>
              <q-td
                key="action"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <div class="row items-center justify-between no-wrap">
                  <q-btn
                    size="sm"
                    round
                    rounded
                    color="negative"
                    icon="update"
                    @click="loadtype(props.row)"
                    class="q-mr-xs"
                    v-show="sessionService.includes('change_serviceprovider')"
                  />
                  <q-btn
                    size="sm"
                    round
                    rounded
                    color="negative"
                    icon="delete"
                    @click="remove(props.row)"
                    class="q-mr-xs"
                    v-show="sessionService.includes('delete_serviceprovider')"
                  />
                </div>
              </q-td>
            </q-tr>
          </q-table>
        </q-card-section>
        <!-- <q-card-actions align="right" class="bg-primary text-white">
          <q-btn push rounded color="primary" @click="SaveType">Submit</q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions> -->
      </q-card>
    </q-dialog>

    <q-dialog
      v-model="modal_form_type"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw;">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_type"
            ref="form_type"
            :rules="rules_type"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Provider" prop="provider">
              {{ form_type.provider_name }}
            </el-form-item>
            <el-form-item label="Type Game" prop="type_id">
              <q-select
                filled
                label="Select Type Game"
                v-model="form_type.type_id"
                :options="type_options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
                v-show="sessionTypeGame.includes('view_type')"
              />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn
            push
            rounded
            color="primary"
            @click="SaveType"
            v-show="sessionService.includes('add_serviceprovider')"
          >
            Submit
          </q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script>
export default {
  name: "Provider",
  data() {
    return {
      data: [],
      game: [],
      columns: [
        {
          name: "No",
          label: "No",
          field: "No",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "name",
          label: "Name",
          field: "name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "code",
          label: "Code",
          field: "code",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "type_name",
          label: "Type",
          field: "type_name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "image",
          label: "Image",
          field: "image",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "status",
          label: "Status",
          field: "status",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "action",
          label: "Action",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      filter_game: "",
      separator: "horizontal",
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 10,
        rowsNumber: 10
      },
      pagination_game: {
        sortBy: null,
        descending: false,
        page: 1,
        rowsPerPage: 10
      },
      btn: [
        { label: "Disable", color: "red" },
        { label: "Enable", color: "primary" }
      ],
      percent: 0,
      commission: 0,
      modal_add: false,
      modal_add_game: false,
      modal_edit_game: false,
      options: [
        { value: 1, label: "Enable" },
        { value: 0, label: "Disable" }
      ],
      type_options: [],
      columns_game: [
        {
          name: "No",
          label: "No",
          field: "No",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "name",
          label: "Name",
          field: "name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "code",
          label: "Code",
          field: "code",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "type_id",
          label: "Type",
          field: "type_id",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "image",
          label: "Image ",
          field: "image",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "status",
          label: "Status",
          field: "status",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "action",
          label: "Action",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      form: {
        name: "",
        code: "",
        type: "",
        percent: 0,
        commission: 0,
        image: null,
        game: []
      },
      form_game: {
        name: "",
        code: "",
        type_id: "",
        image: null
      },
      edit_game: {},
      rules: {
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        code: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        percent: [
          { required: true, message: "Please input percent", trigger: "blur" }
        ],
        type: [
          {
            required: true,
            message: "Please select type game",
            trigger: "change"
          }
        ]
      },
      rules_game: {
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        code: [
          { required: true, message: "Please input code", trigger: "blur" }
        ],
        type_id: [
          {
            required: true,
            message: "Please select type game",
            trigger: "change"
          }
        ],
        image: [
          { required: true, message: "Please select image", trigger: "change" }
        ]
      },
      rules_game_edit: {
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        code: [
          { required: true, message: "Please input code", trigger: "blur" }
        ],
        type_id: [
          {
            required: true,
            message: "Please select type game",
            trigger: "change"
          }
        ]
      },
      permissions:
        this.$q.sessionStorage.getItem("permissions")["provider"] != undefined
          ? this.$q.sessionStorage.getItem("permissions")["provider"]
          : [],
      sessionGame:
        this.$q.sessionStorage.getItem("permissions")["game"] != undefined
          ? this.$q.sessionStorage.getItem("permissions")["game"]
          : [],
      sessionService:
        this.$q.sessionStorage.getItem("permissions")["serviceprovider"] !=
        undefined
          ? this.$q.sessionStorage.getItem("permissions")["serviceprovider"]
          : [],
      sessionTypeGame:
        this.$q.sessionStorage.getItem("permissions")["type"] != undefined
          ? this.$q.sessionStorage.getItem("permissions")["type"]
          : [],
      loading: true,
      filter: {},
      modal_type: false,
      modal_form_type: false,
      data_type: [],
      form_type: {
        id: null,
        provider_id: null,
        type_id: null,
        // type_playlist: null,
        status: null
      },
      rules_type: {
        type_id: [
          {
            required: true,
            message: "Please select type game",
            trigger: "change"
          }
        ]
      },
      columns_type: [
        {
          name: "No",
          label: "No",
          field: "No",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "provider",
          label: "Provider",
          field: "provider_name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "type_name",
          label: "Type",
          field: "type_name",
          require: true,
          align: "left",
          stortable: true
        },
        // { name: 'type_playlist_name', label: 'Type Play List', field: 'type_playlist_name', require: true, align: 'left', stortable: true },
        // {name: 'status', label: 'Status', field: 'status', require: true, align: 'left', stortable: true},
        {
          name: "action",
          label: "Action",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        }
      ]
    };
  },

  async created() {
    await this.getdata();
    await this.gettypegame();
  },

  methods: {
    async onRequest(props) {
      try {
        this.loading = true;
        const { page, rowsPerPage, sortBy, descending } = props.pagination;
        this.filter.page_limit = rowsPerPage;
        this.filter.page = page;
        if (this.filter.name == "") {
          delete this.filter.name;
        }
        if (this.filter.code == "") {
          delete this.filter.code;
        }
        let result = await this.$services.provider.read(this.filter);
        this.pagination.rowsNumber = result.total;
        const fetchCount =
          rowsPerPage === 0 ? this.pagination.rowsNumber : rowsPerPage;
        const startRow = (page - 1) * rowsPerPage;
        this.data = result.results;
        this.$services.updateindex(this.data);
        this.pagination.page = page;
        this.pagination.rowsPerPage = rowsPerPage;
        this.pagination.sortBy = sortBy;
        this.pagination.descending = descending;
        this.loading = false;
      } catch (e) {
        this.$services.error(e.response, this.$router);
      }
    },

    async getdata() {
      this.onRequest({
        pagination: this.pagination
      });
    },

    add() {
      if (this.permissions.includes("add_provider")) {
        this.form = {
          name: "",
          code: "",
          type: "",
          percent: 0,
          commission: 0,
          image: null,
          game: []
        };
        this.game = [];
        this.modal_add = true;
      }
    },

    ChangeStatus(row) {
      const prev = row.status == 0 ? 1 : 0;
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Status to Provider ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.$services.provider
            .update(row, row.id)
            .then(function(data) {
              ctx.getdata();
              ctx.$services.success("Update Provider Success");
            })
            .catch(function(e) {
              row.status = prev;
              ctx.$services.error(e.response, ctx.$router);
            });
        })
        .onCancel(() => {
          row.status = prev;
          // console.log(">>>> Cancel");
        });
    },

    async gettypegame() {
      let ctx = this;
      this.$services.typegame
        .read({})
        .then(function(data) {
          data.forEach(row => {
            ctx.type_options.push({ value: row.id, label: row.name });
          });
        })
        .catch(function(e) {
          ctx.$services.error(e.response, ctx.$router);
        });
    },

    async Create() {
      let ctx = this;
      this.$refs.form.validate(valid => {
        if (valid) {
          this.form.game = this.game;
          if (this.form.id) {
            this.$services.provider
              .update(this.form, this.form.id)
              .then(function(data) {
                ctx.$services.success("Update Provider and Game Success");
                ctx.getdata();
                ctx.modal_add = false;
              })
              .catch(function(e) {
                ctx.$services.error(e.response, ctx.$router);
              });
          } else {
            this.$services.provider
              .add(this.$data.form)
              .then(function(data) {
                ctx.$services.success("Save Provider and Game Success");
                ctx.getdata();
                ctx.modal_add = false;
              })
              .catch(function(e) {
                ctx.$services.error(e.response, ctx.$router);
              });
          }
        }
      });
    },
    // top code provider

    getNameType(value) {
      let name = "";
      this.type_options.forEach(row => {
        if (row.value === value) {
          name = row.label;
        }
      });

      return name;
    },

    uploadProvider(e) {
      const image = e.target.files[0];
      const reader = new FileReader();
      reader.readAsDataURL(image);
      reader.onload = e => {
        this.form.image = e.target.result.split(",")[1];
      };
    },

    uploadImage(e) {
      const image = e.target.files[0];
      const reader = new FileReader();
      reader.readAsDataURL(image);
      reader.onload = e => {
        this.form_game.image = e.target.result.split(",")[1];
      };
    },

    uploadImageEdit(e) {
      const image = e.target.files[0];
      const reader = new FileReader();
      reader.readAsDataURL(image);
      reader.onload = e => {
        this.edit_game.image = e.target.result.split(",")[1];
      };
    },

    ConvertImage(image) {
      if (image != "") {
        if (/(http(s?)):\/\//i.test(image)) {
          return image;
        } else {
          return `data:image/png;base64,${image}`;
        }
      } else {
        return "";
      }
    },

    addGame() {
      if (this.sessionGame.includes("add_game")) {
        this.$data.modal_add_game = true;
        this.$data.form_game = {
          name: "",
          code: "",
          type_id: "",
          image: null
        };
      }
    },

    async insert() {
      this.$refs.form_game.validate(valid => {
        if (valid) {
          this.game.push({
            name: this.form_game.name,
            code: this.form_game.code,
            type_id: this.form_game.type_id,
            status: 1,
            image: this.form_game.image
          });
          this.$services.updateindex(this.game);
          this.modal_add_game = false;
        }
      });
    },

    loadgame(row) {
      this.edit_game = row;
      this.modal_edit_game = true;
    },

    UpdateGame() {
      let ctx = this;
      this.$refs.edit_game.validate(valid => {
        if (valid) {
          if (Object.keys(this.edit_game).includes("id")) {
            this.$services.provider
              .update_game(this.edit_game, this.edit_game.id)
              .then(function(data) {
                ctx.$services.success("Update Provider and Game Success");
              })
              .catch(function(e) {
                ctx.$services.error(e.response, ctx.$router);
              });
          } else {
            let index = this.form.game.findIndex(
              x => x.No === this.edit_game.No
            );
            this.form.game[index]["name"] = this.edit_game.name;
            this.form.game[index]["code"] = this.edit_game.code;
            this.form.game[index]["type_id"] = this.edit_game.type_id;
            this.form.game[index]["image"] = this.edit_game.image;
          }
          this.modal_edit_game = false;
        }
      });
    },

    async load(row) {
      try {
        this.form = row;
        this.game = [];
        this.game = await this.$services.game.read({ provider: row.id });
        this.modal_add = true;
        this.$services.updateindex(this.game);
      } catch (e) {
        this.$services.error(e.response, ctx.$router);
      }
    },

    opentype(row) {
      this.modal_type = true;
      this.form_type.provider_id = row.id;
      this.form_type.provider_name = row.name;
      this.form_type.type_id = null;
      this.form_type.id = null;
      this.get_serviceprovider(row.id);
    },

    async get_serviceprovider(id) {
      this.data_type = await this.$services.serviceprovider.read(id);
      this.$services.updateindex(this.data_type);
    },

    addType() {
      this.modal_form_type = true;
      this.form_type.type_id = null;
      this.form_type.id = null;
      this.form_type.type_playlist = null;
    },

    loadtype(row) {
      this.modal_form_type = true;
      this.form_type.type_id = row.type_id;
      this.form_type.id = row.id;
      this.form_type.type_playlist = row.type_playlist;
    },

    async SaveType() {
      let ctx = this;
      this.$refs.form_type.validate(valid => {
        if (valid) {
          if (this.form_type.id != null) {
            this.$services.serviceprovider
              .update(
                this.form_type,
                this.form_type.provider_id,
                this.form_type.id
              )
              .then(function(data) {
                ctx.get_serviceprovider(ctx.form_type.provider_id);
                ctx.$services.success("Update Service Provider Success");
                ctx.modal_form_type = false;
              })
              .catch(function(e) {
                ctx.$services.error(e.response, ctx.$router);
              });
          } else {
            this.$services.serviceprovider
              .add(this.form_type, this.form_type.provider_id)
              .then(function(data) {
                ctx.get_serviceprovider(ctx.form_type.provider_id);
                ctx.$services.success("Create Service Provider Success");
                ctx.modal_form_type = false;
              })
              .catch(function(e) {
                ctx.$services.error(e.response, ctx.$router);
              });
          }
        }
      });
    },

    async remove(row) {
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Delete Service Provider ${row.type_name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.$services.serviceprovider
            .remove(row.id)
            .then(function(e) {
              ctx.get_serviceprovider(row.provider_id);
              ctx.$services.success(
                "Delete Service Provider " + row.type_name + " Success"
              );
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        })
        .onCancel(() => {
          // console.log('>>>> Cancel')
        });
    },

    ChangeStatusService(row) {
      const prev = row.status == 0 ? 1 : 0;
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Status Service Provider ${row.type_name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.$services.serviceprovider
            .update(row, row.provider_id, row.id)
            .then(function(data) {
              ctx.getdata();
              ctx.$services.success("Update Provider Success");
            })
            .catch(function(e) {
              row.status = prev;
              ctx.$services.error(e.response, ctx.$router);
            });
        })
        .onCancel(() => {
          row.status = prev;
          // console.log(">>>> Cancel");
        });
    },

    ChangeStatusGame(row) {
      const prev = row.status == 0 ? 1 : 0;
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Status to Game ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.$services.provider
            .update_game(row, row.id)
            .then(function(data) {
              ctx.getdata();
              ctx.$services.success("Update Game Success");
            })
            .catch(function(e) {
              row.status = prev;
              ctx.$services.error(e.response, ctx.$router);
            });
        })
        .onCancel(() => {
          row.status = prev;
          // console.log(">>>> Cancel");
        });
    }
  },

  computed: {
    pagesNumber() {
      return Math.ceil(this.total / this.pagination.rowsPerPage);
    }
  }
};
</script>

<style lang="stylus">
.my-sticky-column-table /*
      specifying max-width so the example can
      highlight the sticky column on any browser window

    max-width 600px
    */
  /* bg color is important for th; just specify one */

  thead tr:first-child th:first-child
    background-color #fff
    opacity 1

  td:first-child
    background-color #f5f5dc

  thead tr:first-child th:first-child, td:first-child
    position sticky
    left 0
    z-index 1
</style>

<style type="text/css">
img {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 100%;
}

.image {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 50%;
}
</style>
